from m5config import *
import MemConfig
import FuncUnitConfig

def new(name, root):
    cpu = FullCPU(name, root)
    (cpu.icache, cpu.dcache) = MemConfig.new(root)
    cpu.iq = StandardIQ('IQ', size=64, caps=[0,0,0,0])
    cpu.iq_comm_latency = 1
    cpu.fupools = FuncUnitConfig.new('FUP')
    cpu.lsq_size = 32
    cpu.rob_size = 196
    cpu.rob_caps = [0, 0, 0, 0]
    cpu.storebuffer_size = 32
    cpu.width = 8
    cpu.issue_bandwidth = [8, 8]
    cpu.prioritized_issue = False
    cpu.thread_weights = [1, 1, 1, 1]
    cpu.dispatch_to_issue = 1
    cpu.decode_to_dispatch = 15
    cpu.mispred_recover = 3
    cpu.fetch_branches = 3
    cpu.ifq_size = 32
    cpu.num_icache_ports = 1

    bp = BranchPred('bpred', pred_class='hybrid',
                    local_hist_regs=2*K, local_hist_bits=11,
                    local_index_bits=11, local_xor=false,
                    global_hist_bits=13, global_index_bits=13, global_xor=false,
                    choice_index_bits=13, choice_xor=false,
                    ras_size=16, btb_size=4*K, btb_assoc=4)

    cpu.branch_pred = bp

    return cpu
