from m5config import *

class BaseL1Cache(BaseCache):
    in_bus=NULL; size=64*K; assoc=2; block_size=64; tgts_per_mshr=16

def new(root):
    il1 = BaseL1Cache('IL1', root, hit_latency=1, mshrs=8)
    dl1 = BaseL1Cache('DL1', root, hit_latency=3, mshrs=32)
    dl1.repl = GenRepl('Gen', num_pools=16, fresh_res=30, pool_res=12)
    l2 = BaseCache('L2', root, size=2*M, assoc=32768, block_size=64,
                   hit_latency=10, mshrs=92, tgts_per_mshr=16)
    toL2Bus = Bus('ToL2bus', root, width=64, clock_ratio=1)
    il1.out_bus = dl1.out_bus = l2.in_bus = toL2Bus
    mem = BaseMemory('SDRAM', root, latency=100)
    toMemBus = Bus('ToMembus', root, width=16, clock_ratio=1)
    l2.out_bus = mem.in_bus = toMemBus
    return (il1, dl1)
