from m5config import *

def new(root, num_cpus):
    prog = LiveProcess('prog', root)

    msi = CoherenceProtocol('MSI', root, protocol='msi')
    hier = HierParams('hier', root, do_data=False, do_events=False)
    toMembus = Bus('toMembus', root, width=16, clock_ratio=1, hier=hier)

    dram = BaseMemory('DRAM', root, in_bus=toMembus, latency=100, hier=hier)

    class L1Cache(BaseCache):
        size=64*K; assoc=2; block_size=64; hit_latency=1;
        mshrs=4; tgts_per_mshr=8; out_bus=toMembus;
        protocol=msi; hier=root.hier

    for i in range(num_cpus):
        cpu = SimpleCPU('cpu%d' % i, root, workload=prog)
        cpu.icache = L1Cache('il1', cpu, mshrs=4)
        cpu.dcache = L1Cache('dl1', cpu, mshrs=4)

