/* $Id: s.pmap.h 1.5 03/10/12 22:59:41-04:00 binkertn@zans.eecs.umich.edu $ */

/*
 * Copyright (c) 1996 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Chris G. Demetriou
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */

#define	ALPHA_PGSHIFT		13
#define	PTESHIFT		3	// pte size == 1 << PTESHIFT
#define	ALPHA_PGBYTES		(1L << ALPHA_PGSHIFT)
#define NPTEPG_SHIFT		(ALPHA_PGSHIFT - PTESHIFT)
#define NPTEPG			(1L << NPTEPG_SHIFT)
#define PTEMASK			(NPTEPG - 1)
#define	PGMASK			(~(ALPHA_PGBYTES - 1))
#define	PGOFSET			(ALPHA_PGBYTES - 1)	// byte off. into pg

#define	ALPHA_USEG_BASE		ULL(0x0)		// virtual
#define	ALPHA_USEG_END		ULL(0x000003ffffffffff)
#define	ALPHA_K0SEG_BASE	ULL(0xfffffc0000000000)	// direct-mapped
#define	ALPHA_K0SEG_END		ULL(0xfffffdffffffffff)
#define	ALPHA_K1SEG_BASE	ULL(0xfffffe0000000000)	// virtual
#define	ALPHA_K1SEG_END		ULL(0xffffffffffffffff)

#define ALPHA_K0SEG_TO_PHYS(x)	((x) & ~ALPHA_K0SEG_BASE)
#define ALPHA_PHYS_TO_K0SEG(x)	((x) | ALPHA_K0SEG_BASE)

#define	ALPHA_PTE_VALID			0x0001

#define	ALPHA_PTE_FAULT_ON_READ		0x0002
#define	ALPHA_PTE_FAULT_ON_WRITE	0x0004
#define	ALPHA_PTE_FAULT_ON_EXECUTE	0x0008

#define	ALPHA_PTE_ASM			0x0010		// addr. space match
#define	ALPHA_PTE_GRANULARITY		0x0060		// granularity hint

#define	ALPHA_PTE_PROT			0xff00
#define	ALPHA_PTE_KR			0x0100
#define	ALPHA_PTE_UR			0x0200
#define	ALPHA_PTE_KW			0x1000
#define	ALPHA_PTE_UW			0x2000

#define	ALPHA_PTE_WRITE			(ALPHA_PTE_KW | ALPHA_PTE_UW)

#define	ALPHA_PTE_SOFTWARE		0x00000000ffff0000
#define	ALPHA_PTE_PALCODE		(~ALPHA_PTE_SOFTWARE) // shorthand

#define	ALPHA_PTE_PFN			0xffffffff00000000

#define	ALPHA_PTE_TO_PFN(pte)		((pte) >> 32)
#define	ALPHA_PTE_FROM_PFN(pfn)		((pfn) << 32)
#define	PG_PFNUM(x)			ALPHA_PTE_TO_PFN(x)
#define	PMAP_PTE_PA(pte)		(PG_PFNUM(pte) << ALPHA_PGSHIFT)

#define alpha_trunc_page(x)	((uint64_t)(x) & ~(ALPHA_PGBYTES-1))
#define alpha_round_page(x)     ((((uint64_t)(x)) + ALPHA_PGBYTES - 1) & ~(ALPHA_PGBYTES-1))
