/* $Id: s.pciareg.h 1.6 03/09/05 23:05:32-00:00 binkertn $ */

/*
 * Copyright (c) 2003
 * The Regents of The University of Michigan
 * All Rights Reserved
 *
 * Permission is granted to use, copy, create derivative works and
 * redistribute this software and such derivative works for any
 * purpose, so long as the copyright notice above, this grant of
 * permission, and the disclaimer below appear in all copies made; and
 * so long as the name of The University of Michigan is not used in
 * any advertising or publicity pertaining to the use or distribution
 * of this software without specific, written prior authorization.
 *
 * THIS SOFTWARE IS PROVIDED AS IS, WITHOUT REPRESENTATION FROM THE
 * UNIVERSITY OF MICHIGAN AS TO ITS FITNESS FOR ANY PURPOSE, AND
 * WITHOUT WARRANTY BY THE UNIVERSITY OF MICHIGAN OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE. THE REGENTS OF THE UNIVERSITY OF MICHIGAN SHALL NOT BE
 * LIABLE FOR ANY DAMAGES, INCLUDING DIRECT, SPECIAL, INDIRECT,
 * INCIDENTAL, OR CONSEQUENTIAL DAMAGES, WITH RESPECT TO ANY CLAIM
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OF THE SOFTWARE, EVEN
 * IF IT HAS BEEN OR IS HEREAFTER ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */

/* @file
 * Device register definitions for the PCIA device
 */

#ifndef __PCIAREG_H__
#define __PCIAREG_H__

// Sparse address mappings
#define PCIADDR_MASK		(ULL(0x7fffffff))
#define PCICONF_DEV_SHIFT	(16)
#define PCICONF_FUN_SHIFT	(13)
#define PCICONF_REG_SHIFT	(5)
#define PCICONF_BEN_SHIFT	(3)
#define PCICONF_DEV_MASK	(0xff)
#define PCICONF_FUN_MASK	(0x7)
#define PCICONF_REG_MASK	(0xff)
#define PCICONF_BEN_MASK	(0xf)

// Registers and memory regions
#define PCIA_MASK		0xffffff
#define PCIA_PCI0		0x000000
#define PCIA_PCI1		0x200000
#define PCIA_PCI2		0x400000
#define PCIA_PRESENT		0x800000
#define PCIA_TBIT		0xa00000
#define PCIA_MCTL		0xc00000
#define PCIA_IBR		0xe00000

#define PCIA_PCI_CTL		0x00
#define PCIA_PCI_MRETRY		0x80
#define PCIA_PCI_GPR		0x100
#define PCIA_PCI_ERR		0x180
#define PCIA_PCI_FADR		0x200
#define PCIA_PCI_IMASK		0x280
#define PCIA_PCI_DIAG		0x300
#define PCIA_PCI_IPEND		0x380
#define PCIA_PCI_IPROG		0x400
#define PCIA_PCI_WMASK_A	0x480
#define PCIA_PCI_WBASE_A	0x500
#define PCIA_PCI_TBASE_A	0x580
#define PCIA_PCI_WMASK_B	0x600
#define PCIA_PCI_WBASE_B	0x680
#define PCIA_PCI_TBASE_B	0x700
#define PCIA_PCI_WMASK_C	0x780
#define PCIA_PCI_WBASE_C	0x800
#define PCIA_PCI_TBASE_C	0x880
#define PCIA_PCI_ERRVEC		0x900
#define PCIA_PCI_DEVVEC		0x1000

#endif // __PCIAREG_H__
