from matplotlib.matlab import *
from m5stats_db import *

def graphStat(runs, stat, samples=None, bins=None):
    N = len(runs)
    data = zeros(N, Float)
    count = 0
    runnames = []
    for run in runs:
        data[count] = sumAvg(run,stat,samples,bins)
        count = count + 1
        runnames.append(getRunName(run))
    
 
    ind = arange(N)
    width = graphStat.width
    print data
    print ind
    p1 = bar(ind, data, graphStat.width, color=graphStat.color)
    ylabel(graphStat.ylabel)
    xlabel(graphStat.xlabel)
    title(graphStat.title)
    
    set(gca(), 'xticks', ind+(graphStat.width/2))
    if len(graphStat.xlabels) > 0:
        set(gca(), 'xticklabels',  graphStat.xlabels)
    else:
        set(gca(), 'xticklabels',  runnames)
    set(gca(), 'xlim', [-width,len(ind)])
    # some more complex tick stuff can be done here or a ledgend
    show()

#### Default graph parameters ####
graphStat.width = .3      
graphStat.color = 'r'
graphStat.ylabel = 'change me!'
graphStat.xlabel = 'change me!'
graphStat.title = 'change me!'
graphStat.xlabels = []


def graphFormula(func, runs):
    N = len(runs)
    data = zeros(N, Float)
    count = 0
    runnames = []
    for run in runs:
        data[count] = func(run)
        count = count + 1
        runnames.append(getRunName(run))
    
    ind = arange(N)
    width = graphFormula.width
    print data
    print ind
    p1 = bar(ind, data, graphFormula.width, color=graphFormula.color)
    ylabel(graphFormula.ylabel)
    xlabel(graphFormula.xlabel)
    title(graphFormula.title)
    
    set(gca(), 'xticks', ind+(graphFormula.width/2))
    if len(graphFormula.xlabels) > 0:
        set(gca(), 'xticklabels',  graphFormula.xlabels)
    else:
        set(gca(), 'xticklabels',  runnames)
    set(gca(), 'xlim', [-width,len(ind)])
    # some more complex tick stuff can be done here or a ledgend
    show()

graphFormula.width = .3      
graphFormula.color = 'r'
graphFormula.ylabel = 'change me!'
graphFormula.xlabel = 'change me!'
graphFormula.title = 'change me!'
graphFormula.xlabels = []


